/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

let gPrefBranch = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefBranch);

var ccd_bundle = srGetStrBundle("chrome://customcalendardefaults/locale/ccd-prefs.properties");

function toggleEventUI() {
  let ccdCheckEventPrivacy = document.getElementById("ccdCheckEventPrivacy");
  let ccdSetEventPrivacy = document.getElementById("ccdSetEventPrivacy");
  let hideableItems = new Array();
  hideableItems = ccdSetEventPrivacy.getElementsByAttribute("hideable", true);
  if (ccdCheckEventPrivacy.hasAttribute("checked", true)) {
    for (let i = 0; i < hideableItems.length; ++i) {
      let item = hideableItems[i];
	  if (item.hasAttribute("disabled", true)) {
  	    item.removeAttribute("disabled");
	  }
    }
  } else {
    for (let i = 0; i < hideableItems.length; ++i) {
      let item = hideableItems[i];
	  if (!item.hasAttribute("disabled", true)) {
  	    item.setAttribute("disabled", true);
	  }
    }
  }
}

function toggleTaskUI() {
  let ccdCheckTaskPrivacy = document.getElementById("ccdCheckTaskPrivacy");
  let ccdSetTaskPrivacy = document.getElementById("ccdSetTaskPrivacy");
  let hideableItems = new Array();
  hideableItems = ccdSetTaskPrivacy.getElementsByAttribute("hideable", true);
  if (ccdCheckTaskPrivacy.hasAttribute("checked", true)) {
    for (let i = 0; i < hideableItems.length; ++i) {
      let item = hideableItems[i];
	  if (item.hasAttribute("disabled", true)) {
  	    item.removeAttribute("disabled");
	  }
    }
  } else {
    for (let i = 0; i < hideableItems.length; ++i) {
      let item = hideableItems[i];
	  if (!item.hasAttribute("disabled", true)) {
  	    item.setAttribute("disabled", true);
	  }
    }
  }
}

function ccdResetCalendarDefaults() {
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.status")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.status");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.privacy")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.privacy");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.privacy.state")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.privacy.state");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.priority")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.priority");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.showTimeAs")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.showTimeAs");
  }
  if (gPrefBranch.prefHasUserValue("calendar.events.defaultTransparency.standard.transparent")) {
    void gPrefBranch.clearUserPref("calendar.events.defaultTransparency.standard.transparent");
  }
  if (gPrefBranch.prefHasUserValue("calendar.events.defaultTransparency.allday.transparent")) {
    void gPrefBranch.clearUserPref("calendar.events.defaultTransparency.allday.transparent");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.status")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.status");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.privacy")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.privacy");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.privacy.state")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.privacy.state");
  }
  if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.priority")) {
    void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.priority");
  }
  onLoadCcdPrefsPane();
}

function onLoadCcdPrefsPane() {
  let ccdEventPriority = document.getElementById("ccdEventPriority");
  let defaultEventPriority = gPrefBranch.getCharPref("extensions.customcalendardefaults.event.priority");
  let eventPriorityNone = ccd_bundle.GetStringFromName( "eventPriorityNone.label" );
  let eventPriorityLow = ccd_bundle.GetStringFromName( "eventPriorityLow.label" );
  let eventPriorityHigh = ccd_bundle.GetStringFromName( "eventPriorityHigh.label" );
  let eventPriorityNormal = ccd_bundle.GetStringFromName( "eventPriorityNormal.label" );
  if (defaultEventPriority == "0") {
    ccdEventPriority.setAttribute("label", eventPriorityNone);
  } else if (defaultEventPriority == "1") {
    ccdEventPriority.setAttribute("label", eventPriorityHigh);
  } else if (defaultEventPriority == "5") {
    ccdEventPriority.setAttribute("label", eventPriorityNormal);
  } else if (defaultEventPriority == "9") {
    ccdEventPriority.setAttribute("label", eventPriorityLow);
  }
  
  let ccdEventStatus = document.getElementById("ccdEventStatus");
  let defaultEventStatus = gPrefBranch.getCharPref("extensions.customcalendardefaults.event.status");
  let eventStatusNone = ccd_bundle.GetStringFromName( "eventStatusNone.label" );
  let eventStatusTentative = ccd_bundle.GetStringFromName( "eventStatusTentative.label" );
  let eventStatusConfirmed = ccd_bundle.GetStringFromName( "eventStatusConfirmed.label" );
  let eventStatusCancelled = ccd_bundle.GetStringFromName( "eventStatusCancelled.label" );
  if (defaultEventStatus == "") {
    ccdEventStatus.setAttribute("label", eventStatusNone);
  } else if (defaultEventStatus == "TENTATIVE") {
    ccdEventStatus.setAttribute("label", eventStatusTentative);
  } else if (defaultEventStatus == "CONFIRMED") {
    ccdEventStatus.setAttribute("label", eventStatusConfirmed);
  } else if (defaultEventStatus == "CANCELLED") {
    ccdEventStatus.setAttribute("label", eventStatusCancelled);
  }

  let ccdSogoConflict = gPrefBranch.getBoolPref("extensions.customcalendardefaults.sogoconflict");
  if (ccdSogoConflict) {
    let ccdCheckEventPrivacyRow = document.getElementById("ccdCheckEventPrivacyRow");
    ccdCheckEventPrivacyRow.setAttribute("hidden", true);
    ccdSetEventPrivacy = document.getElementById("ccdSetEventPrivacy");
    ccdSetEventPrivacy.setAttribute("hidden", true);
    if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.privacy")) {
      void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.privacy");
    }
    if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.event.privacy.state")) {
      void gPrefBranch.clearUserPref("extensions.customcalendardefaults.event.privacy.state");
    }
  } else {
    let ccdEventPrivacyPref = gPrefBranch.getBoolPref("extensions.customcalendardefaults.event.privacy");
    let ccdSetEventPrivacy = document.getElementById("ccdSetEventPrivacy");
    if (ccdEventPrivacyPref == false) {
      let hideableItems = new Array();
      hideableItems = ccdSetEventPrivacy.getElementsByAttribute("hideable", true);
      for (let i = 0; i < hideableItems.length; ++i) {
        let item = hideableItems[i];
	    if (!item.hasAttribute("disabled", true)) {
  	      item.setAttribute("disabled", true);
	    }
      }
    }
  
    let ccdEventPrivacy = document.getElementById("ccdEventPrivacy");
    let defaultEventPrivacy = gPrefBranch.getCharPref("extensions.customcalendardefaults.event.privacy.state");
    let eventPrivacyPrivate = ccd_bundle.GetStringFromName( "eventPrivacyPrivate.label" );
    let eventPrivacyConfidential = ccd_bundle.GetStringFromName( "eventPrivacyConfidential.label" );
    let eventPrivacyPublic = ccd_bundle.GetStringFromName( "eventPrivacyPublic.label" );
    if (defaultEventPrivacy == "PRIVATE") {
      ccdEventPrivacy.setAttribute("label", eventPrivacyPrivate);
    } else if (defaultEventPrivacy == "CONFIDENTIAL") {
      ccdEventPrivacy.setAttribute("label", eventPrivacyConfidential);
    } else if (defaultEventPrivacy == "PUBLIC") {
      ccdEventPrivacy.setAttribute("label", eventPrivacyPublic);
    } else {
      ccdEventPrivacy.setAttribute("label", "");
    }
  }

  let ccdTaskPriority = document.getElementById("ccdTaskPriority");
  let defaultTaskPriority = gPrefBranch.getCharPref("extensions.customcalendardefaults.task.priority");
  let taskPriorityNone = ccd_bundle.GetStringFromName( "taskPriorityNone.label" );
  let taskPriorityLow = ccd_bundle.GetStringFromName( "taskPriorityLow.label" );
  let taskPriorityHigh = ccd_bundle.GetStringFromName( "taskPriorityHigh.label" );
  let taskPriorityNormal = ccd_bundle.GetStringFromName( "taskPriorityNormal.label" );
  if (defaultTaskPriority == "0") {
    ccdTaskPriority.setAttribute("label", taskPriorityNone);
  } else if (defaultTaskPriority == "1") {
    ccdTaskPriority.setAttribute("label", taskPriorityHigh);
  } else if (defaultTaskPriority == "5") {
    ccdTaskPriority.setAttribute("label", taskPriorityNormal);
  } else if (defaultTaskPriority == "9") {
    ccdTaskPriority.setAttribute("label", taskPriorityLow);
  }
  
  let ccdTaskStatus = document.getElementById("ccdTaskStatus");
  let defaultTaskStatus = gPrefBranch.getCharPref("extensions.customcalendardefaults.task.status");
  let taskStatusNone = ccd_bundle.GetStringFromName( "taskStatusNone.label" );
  let taskStatusAction = ccd_bundle.GetStringFromName( "taskStatusAction.label" );
  let taskStatusProcess = ccd_bundle.GetStringFromName( "taskStatusProcess.label" );
  let taskStatusCompleted = ccd_bundle.GetStringFromName( "taskStatusCompleted.label" );
  let taskStatusCancelled = ccd_bundle.GetStringFromName( "taskStatusCancelled.label" );
  if (defaultTaskStatus == "") {
    ccdTaskStatus.setAttribute("label", taskStatusNone);
  } else if (defaultTaskStatus == "NEEDS-ACTION") {
    ccdTaskStatus.setAttribute("label", taskStatusAction);
  } else if (defaultTaskStatus == "IN-PROCESS") {
    ccdTaskStatus.setAttribute("label", taskStatusProcess);
  } else if (defaultTaskStatus == "COMPLETED") {
    ccdTaskStatus.setAttribute("label", taskStatusCompleted);
  } else if (defaultTaskStatus == "CANCELLED") {
    ccdTaskStatus.setAttribute("label", taskStatusCancelled);
  }

  if (ccdSogoConflict) {
    let ccdCheckTaskPrivacyRow = document.getElementById("ccdCheckTaskPrivacyRow");
    ccdCheckTaskPrivacyRow.setAttribute("hidden", true);
    ccdSetTaskPrivacy = document.getElementById("ccdSetTaskPrivacy");
    ccdSetTaskPrivacy.setAttribute("hidden", true);
    if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.privacy")) {
      void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.privacy");
    }
    if (gPrefBranch.prefHasUserValue("extensions.customcalendardefaults.task.privacy.state")) {
      void gPrefBranch.clearUserPref("extensions.customcalendardefaults.task.privacy.state");
    }
  } else {
    let ccdTaskPrivacy = document.getElementById("ccdTaskPrivacy");
    let defaultTaskPrivacy = gPrefBranch.getCharPref("extensions.customcalendardefaults.task.privacy.state");
    let taskPrivacyPrivate = ccd_bundle.GetStringFromName( "taskPrivacyPrivate.label" );
    let taskPrivacyConfidential = ccd_bundle.GetStringFromName( "taskPrivacyConfidential.label" );
    let taskPrivacyPublic = ccd_bundle.GetStringFromName( "taskPrivacyPublic.label" );
    if (defaultTaskPrivacy == "PRIVATE") {
      ccdTaskPrivacy.setAttribute("label", taskPrivacyPrivate);
    } else if (defaultTaskPrivacy == "CONFIDENTIAL") {
      ccdTaskPrivacy.setAttribute("label", taskPrivacyConfidential);
    } else if (defaultTaskPrivacy == "PUBLIC") {
      ccdTaskPrivacy.setAttribute("label", taskPrivacyPublic);
    } else {
      ccdTaskPrivacy.setAttribute("label", "");
    }
  
    let ccdTaskPrivacyPref = gPrefBranch.getBoolPref("extensions.customcalendardefaults.task.privacy");
    let ccdSetTaskPrivacy = document.getElementById("ccdSetTaskPrivacy");
    if (ccdTaskPrivacyPref == false) {
      let hideableItems = new Array();
      hideableItems = ccdSetTaskPrivacy.getElementsByAttribute("hideable", true);
      for (let i = 0; i < hideableItems.length; ++i) {
        let item = hideableItems[i];
	    if (!item.hasAttribute("disabled", true)) {
  	      item.setAttribute("disabled", true);
	    }
      }
    }
  }
}
